; Compile with the goldroad assembler 1.7: goldroad mode5test.asm mode5test.bin
; /Mic, 2004


@textarea $8000000
@include start.asm	; boot code



VSync
; In:
;  -
;
; Out:
;  -
  stmfd sp!,{r0-r1}
  mov r0,#$4000000
  add r0,r0,#4		; DISPCNT+4 = DISPSTAT

  VS_loop1
    ldrh r1,[r0]
    ands r1,r1,#1
  bne VS_loop1

  VS_loop2
    ldrh r1,[r0]
    ands r1,r1,#1
  beq VS_loop2

  ldmfd sp!,{r0-r1}
  mov pc,lr




start

bl VSync
bl VSync
bl VSync

mov r0,#$0400
add r0,r0,#5
mov r1,#$4000000
str r0,[r1]		; set mode 5 and enable BG2


ldr r0,=0x4000022
ldr r1,=0xFFFD800
ldr r2,=0xFFFFE00
ldr r3,=0xFFE4
ldr r4,=0xFFF0
strh r4,[r0],#2
strh r3,[r0],#4
str r1,[r0],#4		; Set BG2X (-40 pixels)
str r2,[r0]		; Set BG2Y (-2 pixels)

mov r0,#0
mov r1,#0x6000000
ldr r2,=20480		; 160*128
draw
	strh r0,[r1],#2
	add r0,r0,#1
	subs r2,r2,#1
	bne draw

forever
	bl VSync
	b forever		



@ltorg			; dump literal pool
@endarea

